package sun.reflect;

import java.util.Iterator;
import java.util.ArrayList;
import java.util.List;

class Label
{
    private List<Label.PatchInfo> patches;
    
    public Label() {
        this.patches = new ArrayList();
    }
    
    void add(ClassFileAssembler classFileAssembler, short n, short n2, int n3) {
        this.patches.add(new Label.PatchInfo(classFileAssembler, n, n2, n3));
    }
    
    public void bind() {
        for (Label.PatchInfo patchInfo : this.patches) {
            patchInfo.asm.emitShort(patchInfo.patchBCI, (short)(patchInfo.asm.getLength() - patchInfo.instrBCI));
            patchInfo.asm.setStack(patchInfo.stackDepth);
        }
    }
    
    static class PatchInfo
    {
        final ClassFileAssembler asm;
        final short instrBCI;
        final short patchBCI;
        final int stackDepth;
        
        PatchInfo(ClassFileAssembler asm, short instrBCI, short patchBCI, int stackDepth) {
            this.asm = asm;
            this.instrBCI = instrBCI;
            this.patchBCI = patchBCI;
            this.stackDepth = stackDepth;
        }
    }
}
